<html xmlns:v="urn:schemas-microsoft-com:vml"
xmlns:o="urn:schemas-microsoft-com:office:office"
xmlns:w="urn:schemas-microsoft-com:office:word"
xmlns="http://www.w3.org/TR/REC-html40">

<head>
<meta http-equiv=Content-Type content="text/html; charset=windows-1252">
<meta name=ProgId content=Word.Document>
<meta name=Generator content="Microsoft Word 11">
<meta name=Originator content="Microsoft Word 11">
<title>FOR Clause</title>
<!--[if gte mso 9]><xml>
 <o:DocumentProperties>
  <o:Author>rdolling</o:Author>
  <o:LastAuthor>rdolling</o:LastAuthor>
  <o:Revision>2</o:Revision>
  <o:TotalTime>28</o:TotalTime>
  <o:Created>2007-08-22T18:11:00Z</o:Created>
  <o:LastSaved>2007-08-22T18:11:00Z</o:LastSaved>
  <o:Pages>6</o:Pages>
  <o:Words>1901</o:Words>
  <o:Characters>10840</o:Characters>
  <o:Company>UWSP</o:Company>
  <o:Lines>90</o:Lines>
  <o:Paragraphs>25</o:Paragraphs>
  <o:CharactersWithSpaces>12716</o:CharactersWithSpaces>
  <o:Version>11.8132</o:Version>
 </o:DocumentProperties>
</xml><![endif]--><!--[if gte mso 9]><xml>
 <w:WordDocument>
  <w:ValidateAgainstSchemas/>
  <w:SaveIfXMLInvalid>false</w:SaveIfXMLInvalid>
  <w:IgnoreMixedContent>false</w:IgnoreMixedContent>
  <w:AlwaysShowPlaceholderText>false</w:AlwaysShowPlaceholderText>
  <w:Compatibility>
   <w:BreakWrappedTables/>
   <w:SnapToGridInCell/>
   <w:WrapTextWithPunct/>
   <w:UseAsianBreakRules/>
   <w:UseWord2002TableStyleRules/>
   <w:UseFELayout/>
  </w:Compatibility>
  <w:BrowserLevel>MicrosoftInternetExplorer4</w:BrowserLevel>
 </w:WordDocument>
</xml><![endif]--><!--[if gte mso 9]><xml>
 <w:LatentStyles DefLockedState="false" LatentStyleCount="156">
 </w:LatentStyles>
</xml><![endif]-->
<style>
<!--
 /* Font Definitions */
 @font-face
	{font-family:SimSun;
	panose-1:2 1 6 0 3 1 1 1 1 1;
	mso-font-alt:\5B8B\4F53;
	mso-font-charset:134;
	mso-generic-font-family:auto;
	mso-font-pitch:variable;
	mso-font-signature:3 135135232 16 0 262145 0;}
@font-face
	{font-family:"Arial Black";
	panose-1:2 11 10 4 2 1 2 2 2 4;
	mso-font-charset:0;
	mso-generic-font-family:swiss;
	mso-font-pitch:variable;
	mso-font-signature:647 0 0 0 159 0;}
@font-face
	{font-family:"\@SimSun";
	panose-1:2 1 6 0 3 1 1 1 1 1;
	mso-font-charset:134;
	mso-generic-font-family:auto;
	mso-font-pitch:variable;
	mso-font-signature:3 135135232 16 0 262145 0;}
 /* Style Definitions */
 p.MsoNormal, li.MsoNormal, div.MsoNormal
	{mso-style-parent:"";
	margin:0pt;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	font-size:12.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:SimSun;}
h1
	{mso-style-next:Normal;
	margin-top:12.0pt;
	margin-right:0pt;
	margin-bottom:3.0pt;
	margin-left:0pt;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:1;
	font-size:16.0pt;
	font-family:Arial;
	mso-font-kerning:16.0pt;
	font-weight:bold;}
h5
	{mso-margin-top-alt:auto;
	margin-right:0pt;
	mso-margin-bottom-alt:auto;
	margin-left:0pt;
	mso-pagination:widow-orphan;
	mso-outline-level:5;
	font-size:10.0pt;
	font-family:"Times New Roman";
	font-weight:bold;}
h6
	{mso-style-next:Normal;
	margin-top:12.0pt;
	margin-right:0pt;
	margin-bottom:3.0pt;
	margin-left:0pt;
	mso-pagination:widow-orphan;
	mso-outline-level:6;
	font-size:11.0pt;
	font-family:"Times New Roman";
	font-weight:bold;}
p.MsoCaption, li.MsoCaption, div.MsoCaption
	{mso-style-noshow:yes;
	mso-style-next:Normal;
	margin:0pt;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:SimSun;
	font-weight:bold;}
a:link, span.MsoHyperlink
	{color:blue;
	text-decoration:underline;
	text-underline:single;}
a:visited, span.MsoHyperlinkFollowed
	{color:purple;
	text-decoration:underline;
	text-underline:single;}
p
	{mso-margin-top-alt:auto;
	margin-right:0pt;
	mso-margin-bottom-alt:auto;
	margin-left:0pt;
	mso-pagination:widow-orphan;
	font-size:12.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:SimSun;}
code
	{font-family:"Courier New";
	mso-ascii-font-family:"Courier New";
	mso-fareast-font-family:SimSun;
	mso-hansi-font-family:"Courier New";
	mso-bidi-font-family:"Courier New";}
pre
	{margin:0pt;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	tab-stops:45.8pt 91.6pt 137.4pt 183.2pt 229.0pt 274.8pt 320.6pt 366.4pt 412.2pt 458.0pt 503.8pt 549.6pt 595.4pt 641.2pt 687.0pt 732.8pt;
	font-size:10.0pt;
	font-family:"Courier New";
	mso-fareast-font-family:SimSun;}
p.indent, li.indent, div.indent
	{mso-style-name:indent;
	mso-margin-top-alt:auto;
	margin-right:0pt;
	mso-margin-bottom-alt:auto;
	margin-left:0pt;
	mso-pagination:widow-orphan;
	font-size:12.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:SimSun;}
@page Section1
	{size:612.0pt 792.0pt;
	margin:72.0pt 90.0pt 72.0pt 90.0pt;
	mso-header-margin:36.0pt;
	mso-footer-margin:36.0pt;
	mso-paper-source:0;}
div.Section1
	{page:Section1;}
 /* List Definitions */
 @list l0
	{mso-list-id:2011986812;
	mso-list-template-ids:443433550;}
@list l0:level1
	{mso-level-number-format:bullet;
	mso-level-text:\F0B7;
	mso-level-tab-stop:36.0pt;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ansi-font-size:10.0pt;
	font-family:Symbol;}
@list l1
	{mso-list-id:2096321317;
	mso-list-template-ids:-409988338;}
@list l1:level1
	{mso-level-number-format:bullet;
	mso-level-text:\F0B7;
	mso-level-tab-stop:36.0pt;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ansi-font-size:10.0pt;
	font-family:Symbol;}
@list l1:level2
	{mso-level-number-format:bullet;
	mso-level-text:\F0B7;
	mso-level-tab-stop:72.0pt;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ansi-font-size:10.0pt;
	font-family:Symbol;}
ol
	{margin-bottom:0pt;}
ul
	{margin-bottom:0pt;}
-->
</style>
<!--[if gte mso 10]>
<style>
 /* Style Definitions */
 table.MsoNormalTable
	{mso-style-name:"Table Normal";
	mso-tstyle-rowband-size:0;
	mso-tstyle-colband-size:0;
	mso-style-noshow:yes;
	mso-style-parent:"";
	mso-padding-alt:0pt 5.4pt 0pt 5.4pt;
	mso-para-margin:0pt;
	mso-para-margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-ansi-language:#0400;
	mso-fareast-language:#0400;
	mso-bidi-language:#0400;}
</style>
<![endif]--><!--[if gte mso 9]><xml>
 <o:shapelayout v:ext="edit">
  <o:idmap v:ext="edit" data="1"/>
 </o:shapelayout></xml><![endif]-->
</head>

<body lang=EN-US link=blue vlink=purple style='tab-interval:36.0pt'>

<div class=Section1>

					<a href="#XML_Top">Top of XML documentation</a><br/>
					<a href="#Working_with_XML">Working with XML</a><br/>
					<a href="#Reading_XML">Reading XML</a><br/>
					<a href="#Writing_XML">Writing XML</a><br/>




<a name="XML_Top"></a>
<h1 align=center style='text-align:center'><a name="_for_clause"></a><a
name="_sql_server_and_xml_support"></a><span style='font-size:18.0pt;
font-family:"Arial Black"'>1. SQL Server and XML Support<o:p></o:p></span></h1>

<p>Extensible Markup Language (XML) is a hypertext programming language used to
describe the contents of a set of data and how the data should be output to a
device or displayed in a Web page. Markup languages originated as ways for
publishers to indicate to printers how the content of a newspaper, magazine, or
book should be organized. Markup languages for electronic data perform the same
function for electronic documents that can be displayed on different types of
electronic gear.</p>

<p>Both XML and the Hypertext Markup Language (HTML) are derived from Standard
Generalized Markup Language (SGML). SGML is a very large, complex language that
is difficult to fully use for publishing data on the Web. HTML is a more
simple, specialized markup language than SGML, but has a number of limitations
when working with data on the Web. XML is smaller than SGML and more robust
than HTML, so is becoming an increasingly important language in the exchange of
electronic data through the Web or intra-company networks.</p>

<p>In a relational database such as MSSQL, all operations on the tables in the
database produce a result in the form of a table. The result set of a SELECT
statement is in the form of a table. Traditional client/server applications
that execute a SELECT statement process the results by fetching one row or
block of rows from the tabular result set at a time and mapping the column
values into program variables. Web application programmers, on the other hand,
are more familiar with working with hierarchical representations of data in XML
or HTML documents.</p>



<a name="Working_with_XML"></a><br/>
<a href="#XML_Top">Top of XML documentation</a><br/>
<p class=MsoNormal><span style='font-size:16.0pt;font-family:"Arial Black"'>1. Retrieving
and Writing XML Data<o:p></o:p></span></p>

<p class=MsoNormal>You can execute SQL queries to return results as XML rather
than standard rowsets. These queries can be executed directly or from within
stored procedures. To retrieve results directly, you use the FOR XML clause of
the SELECT statement, and within the FOR XML clause you specify an XML mode:
RAW, AUTO, or EXPLICIT.</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>For example, this SELECT statement retrieves information
from Customers and Orders table in the Northwind database. This query specifies
the AUTO mode in the FOR XML clause:</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>SELECT Customers.CustomerID, ContactName, CompanyName,</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>      
</span>Orders.CustomerID, OrderDate</p>

<p class=MsoNormal>FROM Customers, Orders</p>

<p class=MsoNormal>WHERE Customers.CustomerID = Orders.CustomerID </p>

<p class=MsoNormal>AND (Customers.CustomerID = N'ALFKI' </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>    </span>OR
Customers.CustomerID = N'XYZAA')</p>

<p class=MsoNormal>ORDER BY Customers.CustomerID</p>

<p class=MsoNormal>FOR XML AUTO</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>Whereas you can use the FOR XML clause to retrieve data as
an XML document, you can use the Transact-SQL OPENXML function to insert data
represented as an XML document. OPENXML is a rowset provider similar to a table
or a view, providing a rowset over in-memory XML documents. OPENXML allows
access to XML data as if it is a relational rowset by providing a rowset view
of the internal representation of an XML document. The records in the rowset
can be stored in database tables. OPENXML can be used in SELECT, and SELECT
INTO statements where a source table or view can be specified.</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>The following example shows the use of OPENXML in an INSERT
statement and a SELECT statement. The sample XML document consists of
&lt;Customers&gt; and &lt;Orders&gt; elements. First, the
sp_xml_preparedocument stored procedure parses the XML document. The parsed
document is a tree representation of the nodes (elements, attributes, text,
comments, and so on) in the XML document. OPENXML then refers to this parsed
XML document and provides a rowset view of all or parts of this XML document.
An INSERT statement using OPENXML can insert data from such a rowset into a
database table. Several OPENXML calls can be used to provide rowset view of
various parts of the XML document and process them, for example, inserting them
into different tables (this process is also referred to as &quot;Shredding XML
into tables&quot;). In the following example, an XML document is shredded in a
way that &lt;Customers&gt; elements are stored in the Customers table and
&lt;Orders&gt; elements are stored in the Orders table using two INSERT
statements. </p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>The example also shows a SELECT statement with OPENXML that
retrieves CustomerID and OrderDate from the XML document.</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>DECLARE @hDoc int</p>

<p class=MsoNormal>EXEC sp_xml_preparedocument @hDoc OUTPUT, </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>      </span>N'&lt;ROOT&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>         </span>&lt;Customers
CustomerID=&quot;XYZAA&quot; ContactName=&quot;Joe&quot; </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>              
</span>CompanyName=&quot;Company1&quot;&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>            </span>&lt;Orders
CustomerID=&quot;XYZAA&quot; </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>               </span>OrderDate=&quot;2000-08-25T00:00:00&quot;/&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>            </span>&lt;Orders
CustomerID=&quot;XYZAA&quot; </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>              
</span>OrderDate=&quot;2000-10-03T00:00:00&quot;/&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>        
</span>&lt;/Customers&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>         </span>&lt;Customers
CustomerID=&quot;XYZBB&quot; ContactName=&quot;Steve&quot;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>              
</span>CompanyName=&quot;Company2&quot;&gt;No Orders yet!</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>        
</span>&lt;/Customers&gt;</p>

<p class=MsoNormal><span style='mso-spacerun:yes'>      </span>&lt;/ROOT&gt;'</p>

<p class=MsoNormal>-- Use OPENXML to provide rowset consisting of customer
data.</p>

<p class=MsoNormal>INSERT Customers </p>

<p class=MsoNormal>SELECT * </p>

<p class=MsoNormal>FROM OPENXML(@hDoc, N'/ROOT/Customers') </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>     </span>WITH Customers</p>

<p class=MsoNormal>-- Use OPENXML to provide rowset consisting of order data.</p>

<p class=MsoNormal>INSERT Orders </p>

<p class=MsoNormal>SELECT * </p>

<p class=MsoNormal>FROM OPENXML(@hDoc, N'//Orders') </p>

<p class=MsoNormal><span style='mso-spacerun:yes'>     </span>WITH Orders</p>

<p class=MsoNormal>-- Using OPENXML in a SELECT statement.</p>

<p class=MsoNormal>SELECT * FROM OPENXML(@hDoc, N'/ROOT/Customers/Orders') with
(CustomerID nchar(5) '../@CustomerID', OrderDate datetime)</p>

<p class=MsoNormal>-- Remove the internal representation of the XML document.</p>

<p class=MsoNormal>EXEC sp_xml_removedocument @hDoc</p>

<p class=MsoNormal><o:p>&nbsp;</o:p></p>

<p class=MsoNormal>This illustration shows the parsed XML tree of the preceding
XML document that was created by sp_xml_pareparedocument.</p>



<a name="Reading_XML"></a><br/>
<a href="#XML_Top">Top of XML documentation</a><br/>

<h5><span style='font-size:16.0pt;font-family:"Arial Black"'>1.1 Retrieving XML
DATA - FOR XML Clause<o:p></o:p></span></h5>

<p>FOR clause is used to specify either the BROWSE or the XML option (BROWSE
and XML are unrelated options).</p>

<h5 style='margin:0pt;margin-bottom:.0001pt'><span style='font-size:14.0pt'>Syntax<o:p></o:p></span></h5>

<p style='margin:0pt;margin-bottom:.0001pt'>[ FOR { BROWSE | XML { RAW | AUTO |
EXPLICIT } <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ <b>, </b>XMLDATA
] <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ <b>,</b>
ELEMENTS ]<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ <b>,</b>
BINARY BASE64 ]<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;} <br>
] </p>

<p style='margin:0pt;margin-bottom:.0001pt'><o:p>&nbsp;</o:p></p>

<h5 style='margin:0pt;margin-bottom:.0001pt'><span style='font-size:14.0pt'>Arguments<o:p></o:p></span></h5>

<p style='margin:0pt;margin-bottom:.0001pt'>BROWSE - Specifies that updates be
allowed while viewing the data in a DB-Library browse mode cursor. A table can
be browsed in an application if the table includes a time-stamped column
(defined with the <b>timestamp</b><i> </i>data type), the table has a unique
index, and the FOR BROWSE option is at the end of the SELECT statement(s) sent
to SQL Server. The FOR BROWSE option cannot appear in SELECT statements joined
by the UNION operator.</p>

<p>XML - Specifies that the results of a query are to be returned as an XML
document. One of these XML modes must be specified: RAW, AUTO, EXPLICIT.</p>

<p style='margin-top:0pt;margin-right:0pt;margin-bottom:0pt;margin-left:36.0pt;
margin-bottom:.0001pt'>RAW - Takes the query result and transforms each row in
the result set into an XML element with a generic identifier &lt;row /&gt; as
the element tag.</p>

<p style='margin-top:0pt;margin-right:0pt;margin-bottom:0pt;margin-left:36.0pt;
margin-bottom:.0001pt'>AUTO - Returns query results in a simple, nested XML
tree. Each table in the FROM clause, for which at least one column is listed in
the SELECT clause, is represented as an XML element. The columns listed in the
SELECT clause are mapped to the appropriate element attributes.</p>

<p style='margin-top:0pt;margin-right:0pt;margin-bottom:0pt;margin-left:36.0pt;
margin-bottom:.0001pt'>EXPLICIT - Specifies that the shape of the resulting XML
tree is defined explicitly. Using this mode, queries must be written in a
particular way so that additional information about the desired nesting is
specified explicitly.</p>

<p>XMLDATA - Returns the schema, but does not add the root element to the
result. If XMLDATA is specified, it is appended to the document.</p>

<p>ELEMENTS - Specifies that the columns are returned as subelements.
Otherwise, they are mapped to XML attributes.</p>

<p>BINARY BASE64 - Specifies that the query returns the binary data in binary base64-encoded
format. In retrieving binary data using RAW and EXPLICIT mode, this option must
be specified. This is the default in AUTO mode.</p>

<a name="Writing_XML"></a><br/>
<a href="#XML_Top">Top of XML documentation</a><br/>

<h1><a name="_writing_xml_using_openxml"></a><span style='font-family:"Arial Black"'>1.2
Writing XML Data Using OPENXML<o:p></o:p></span></h1>

<p>OPENXML is a Transact-SQL keyword that provides a rowset over in-memory XML
documents. OPENXML is a rowset provider similar to a table or a view. OPENXML
allows access to XML data as if it is a relational rowset by providing a rowset
view of the internal representation of an XML document. The records in the
rowset can be stored in database tables (similar to the rowsets provided by
tables and views). </p>

<p>OPENXML can be used in SELECT, and SELECT INTO statements wherever rowset
providers, such as a table, a view or OPENROWSET can appear as the source.</p>

<p><span style='mso-spacerun:yes'> </span>To write queries against an XML document
using OPENXML, you must first call <b>sp_xml_preparedocument</b>, which parses
the XML document and returns a handle to the parsed document that is ready for
consumption. The parsed document is a tree representation of various nodes
(elements, attributes, text, comment, and so on) in the XML document. The
document handle is passed to OPENXML, which then provides a rowset view of the
document based on the parameters passed to it.</p>

<p>The internal representation of an XML document must be removed from memory
by calling <b>sp_xml_removedocument </b>system stored procedure to free the
memory.</p>

<p>In retrieving the data, <i>rowpattern</i> is used to identify the nodes in
the XML document that determine the rows. <i>rowpattern</i> is expressed in the
XPath pattern language used in the MSXML XPath implementation. For example, if
the pattern ends in an element or an attribute, a row is created for each
element or attribute node selected by <i>rowpattern</i>.</p>

<p>The <i>flags</i> value provides default mapping. In the <i>SchemaDeclaration</i>,
if no <i>ColPattern</i> is specified, the mapping specified in <i>flags</i> is
assumed. The <i>flags</i> value is ignored if <i>ColPattern</i> is specified in
<i>SchemaDeclaration</i>. The specified <i>ColPattern</i> determines the
mapping (<b>attribute-centric</b> or <b>element-centric</b>) and also the
behavior in dealing with overflow and unconsumed data.</p>

<h6><span style='font-family:"Arial Black"'>Example: Execute a simple SELECT
statement with OPENXML<o:p></o:p></span></h6>

<p style='margin:0pt;margin-bottom:.0001pt'>The XML document in this example
consists of the &lt;Customer&gt;, &lt;Order&gt;, and &lt;OrderDetail&gt;
elements. The OPENXML statement retrieves customer information in a two-column
rowset (<b>CustomerID</b> and <b>ContactName</b>) from the XML document.</p>

<p>First, the <b>sp_xml_preparedocument</b> stored procedure is called to
obtain a document handle. This document handle is passed to OPENXML.</p>

<p style='margin:0pt;margin-bottom:.0001pt'>In the OPENXML statement: </p>

<ul style='margin-top:0pt' type=disc>
 <li class=MsoNormal style='mso-list:l0 level1 lfo2;tab-stops:list 36.0pt'><i>rowpattern</i>
     (/ROOT/Customer) identifies the &lt;Customer&gt; nodes to process.</li>
 <li class=MsoNormal style='mso-list:l0 level1 lfo2;tab-stops:list 36.0pt'>The <i>flags</i>
     parameter value is set to <b>1</b> indicating <b>attribute-centric</b>
     mapping. As a result, the XML attributes map to the columns in the rowset
     defined in <i>SchemaDeclaration</i>.</li>
 <li class=MsoNormal style='mso-list:l0 level1 lfo2;tab-stops:list 36.0pt'>In <i>SchemaDeclaration</i>
     (in the WITH clause), the specified <i>ColName</i> values match the
     corresponding XML attribute names. Therefore, the <i>ColPattern</i>
     parameter is not specified in <i>SchemaDeclaration</i>. </li>
</ul>

<p>And then, the SELECT statement retrieves all the columns in the rowset
provided by OPENXML.</p>

<pre><code>DECLARE @idoc int<o:p></o:p></code></pre><pre><code>DECLARE @doc varchar(1000)<o:p></o:p></code></pre><pre><code>SET @doc ='<o:p></o:p></code></pre><pre><code>&lt;ROOT&gt;<o:p></o:p></code></pre><pre><code>&lt;Customer CustomerID=&quot;VINET&quot; ContactName=&quot;Paul Henriot&quot;&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;Order OrderID=&quot;10248&quot; CustomerID=&quot;VINET&quot; EmployeeID=&quot;5&quot; <o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>          </span></code><code><span
lang=FR style='mso-ansi-language:FR'>OrderDate=&quot;1996-07-04T00:00:00&quot;&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>      </span>&lt;OrderDetail ProductID=&quot;11&quot; Quantity=&quot;12&quot;/&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>      </span></span>&lt;OrderDetail ProductID=&quot;42&quot; Quantity=&quot;10&quot;/&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;/Order&gt;<o:p></o:p></code></pre><pre><code>&lt;/Customer&gt;<o:p></o:p></code></pre><pre><code>&lt;Customer CustomerID=&quot;LILAS&quot; ContactName=&quot;Carlos Gonzlez&quot;&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;Order OrderID=&quot;10283&quot; CustomerID=&quot;LILAS&quot; EmployeeID=&quot;3&quot; <o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>          </span></code><code><span
lang=FR style='mso-ansi-language:FR'>OrderDate=&quot;1996-08-16T00:00:00&quot;&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>      </span>&lt;OrderDetail ProductID=&quot;72&quot; Quantity=&quot;3&quot;/&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>   </span></span>&lt;/Order&gt;<o:p></o:p></code></pre><pre><code>&lt;/Customer&gt;<o:p></o:p></code></pre><pre><code>&lt;/ROOT&gt;'<o:p></o:p></code></pre><pre><code>-- Create an internal representation of the XML document.<o:p></o:p></code></pre><pre><code>EXEC sp_xml_preparedocument @idoc OUTPUT, @doc<o:p></o:p></code></pre><pre><code>-- Execute a SELECT statement using OPENXML rowset provider.<o:p></o:p></code></pre><pre><code>SELECT *<o:p></o:p></code></pre><pre><code>FROM OPENXML (@idoc, '/ROOT/Customer',1)<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>      </span>WITH (CustomerID<span style='mso-spacerun:yes'>  </span>varchar(10),<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>            </span>ContactName varchar(20))<o:p></o:p></code></pre><pre><code>EXEC sp_xml_removedocument @idoc<o:p></o:p></code></pre>

<p>This is the result:</p>

<pre><code><span lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>CustomerID ContactName<span style='mso-spacerun:yes'>          </span><o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>---------- -------------------- <o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>VINET<span style='mso-spacerun:yes'>      </span>Paul Henriot<o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>LILAS<span style='mso-spacerun:yes'>      </span>Carlos Gonzlez<o:p></o:p></span></code></pre>

<p>If the same SELECT statement is executed with <i>flags</i> set to <b>2</b>,
indicating <b>element-centric</b> mapping, because &lt;Customer&gt; elements do
not have any subelements, the values of <b>CustomerID</b> and <b>ContactName</b>
for both the customers are returned as NULL.</p>

<p>If in the XML document, the &lt;CustomerID&gt; and &lt;ContactName&gt; are
subelements, the <b>element-centric </b>mapping retrieves the values.</p>

<pre><code>DECLARE @idoc int<o:p></o:p></code></pre><pre><code>DECLARE @doc varchar(1000)<o:p></o:p></code></pre><pre><code>SET @doc ='<o:p></o:p></code></pre><pre><code>&lt;ROOT&gt;<o:p></o:p></code></pre><pre><code>&lt;Customer&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;CustomerID&gt;VINET&lt;/CustomerID&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;ContactName&gt;Paul Henriot&lt;/ContactName&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;Order OrderID=&quot;10248&quot; CustomerID=&quot;VINET&quot; EmployeeID=&quot;5&quot; OrderDate=&quot;1996-07-04T00:00:00&quot;&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>      </span></code><code><span
lang=FR style='mso-ansi-language:FR'>&lt;OrderDetail ProductID=&quot;11&quot; Quantity=&quot;12&quot;/&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>      </span>&lt;OrderDetail ProductID=&quot;42&quot; Quantity=&quot;10&quot;/&gt;<o:p></o:p></span></code></pre><pre><code><span
lang=FR style='mso-ansi-language:FR'><span style='mso-spacerun:yes'>   </span></span>&lt;/Order&gt;<o:p></o:p></code></pre><pre><code>&lt;/Customer&gt;<o:p></o:p></code></pre><pre><code>&lt;Customer&gt;<span style='mso-spacerun:yes'>   </span><o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;CustomerID&gt;LILAS&lt;/CustomerID&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;ContactName&gt;Carlos Gonzlez&lt;/ContactName&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;Order OrderID=&quot;10283&quot; CustomerID=&quot;LILAS&quot; EmployeeID=&quot;3&quot; OrderDate=&quot;1996-08-16T00:00:00&quot;&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>      </span>&lt;OrderDetail ProductID=&quot;72&quot; Quantity=&quot;3&quot;/&gt;<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>   </span>&lt;/Order&gt;<o:p></o:p></code></pre><pre><code>&lt;/Customer&gt;<o:p></o:p></code></pre><pre><code>&lt;/ROOT&gt;'<o:p></o:p></code></pre><pre><code>-- Create an internal representation of the XML document.<o:p></o:p></code></pre><pre><code>EXEC sp_xml_preparedocument @idoc OUTPUT, @doc<o:p></o:p></code></pre><pre><code>-- Execute a SELECT statement using OPENXML rowset provider.<o:p></o:p></code></pre><pre><code>SELECT<span style='mso-spacerun:yes'>    </span>*<o:p></o:p></code></pre><pre><code>FROM<span style='mso-spacerun:yes'>      </span>OPENXML (@idoc, '/ROOT/Customer',2)<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>           </span>WITH (CustomerID<span style='mso-spacerun:yes'>  </span>varchar(10),<o:p></o:p></code></pre><pre><code><span style='mso-spacerun:yes'>               </span><span style='mso-spacerun:yes'>  </span>ContactName varchar(20))<o:p></o:p></code></pre><pre><code>EXEC sp_xml_removedocument @idoc<o:p></o:p></code></pre>

<p>This is the result:</p>

<pre><code><span lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>CustomerID ContactName<span style='mso-spacerun:yes'>          </span><o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>---------- -------------------- <o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>VINET<span style='mso-spacerun:yes'>      </span>Paul Henriot<o:p></o:p></span></code></pre><pre><code><span
lang=ES-TRAD style='mso-ansi-language:ES-TRAD'>LILAS<span style='mso-spacerun:yes'>      </span>Carlos Gonzlez<o:p></o:p></span></code></pre>

<p><span lang=ES-TRAD style='mso-ansi-language:ES-TRAD'><o:p>&nbsp;</o:p></span></p>

</div>

</body>

</html>
